CREATE TABLE public.banners (
	id int NOT NULL GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
	title varchar NOT NULL
);

CREATE TABLE public.slots (
	id int NOT NULL GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
	title varchar NOT NULL
);

CREATE TABLE public.groups (
	id int NOT NULL GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
	title varchar NOT NULL
);

CREATE TABLE public.rotation (
	banner_id int NOT NULL,
	slot_id int NOT NULL,
	started_at timestamp NOT NULL DEFAULT Now(),
	CONSTRAINT rotation_fk FOREIGN KEY (banner_id) REFERENCES public.banners(id),
	CONSTRAINT rotation_fk_2 FOREIGN KEY (slot_id) REFERENCES public.slots(id)
);
CREATE INDEX rotation_banner_id_idx ON public.rotation (banner_id,slot_id);

CREATE TABLE public.statistics_type (
	id int NOT NULL GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
	title varchar NOT NULL
);

CREATE TABLE public."statistics" (
	type_id int NOT NULL,
	banner_id int NOT NULL,
	slot_id int NOT NULL,
	group_id int NOT NULL,
	date_time timestamp NOT NULL,
	CONSTRAINT statistics_fk_type FOREIGN KEY (type_id) REFERENCES public.statistics_type(id),
	CONSTRAINT statistics_fk_slot FOREIGN KEY (slot_id) REFERENCES public.slots(id),
	CONSTRAINT statistics_fk_group FOREIGN KEY (group_id) REFERENCES public."groups"(id)
);
CREATE INDEX statistics_group_id_idx ON public."statistics" (type_id,banner_id,slot_id,group_id);
